#include <vtoo/term.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
void at_init(void);
void at_exit(void);
void print_marquee(int offset,char* string);

#define BG(color) (color * 256)

#define COLORS 7

int main (int argc, char **argv) {
   at_init();
   char c = '\0';
   int offset = 0;
   set_style(BOLD);
   printf("Positioning can be used to good effect algorithmically:");
   do { 
     if (c == 'q') break;
     offset++;
     offset %= COLORS;
     print_marquee(offset,"Hold Down Enter to Animate! Press Q to Quit");
     flush();     
   } while ((c = getchar()));
   return 0;
}

void print_marquee(int offset,char* string) {
   attributes colors[COLORS] = {RED,GREEN,YELLOW,BLUE,MAGENTA,CYAN,WHITE};
   int i;
   for (i = 0; i < strlen(string); i++) {
      set_style(colors[(offset + i) % COLORS]);
      locate(3,i); putchar(string[i]);
   }
}
void at_init(void) {
   atexit(at_exit);
   clear();
   term_buffer_full();
   echo_off();
   locate(0,0);
   toggle_cursor();
   flush();
}

void at_exit(void) {
   toggle_cursor();
   term_buffer_line();
   set_style(NO_ATTRIBS);
   clear();
   echo_on();
   locate(0,0);
   flush();
}
