#include <vtoo/term.h>
#include <vtoo/input.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void at_init(void);
void at_exit(void);
void draw(void);

int main(int argc, char **argv) {
   at_init();
   draw();
   //atwinch allows you to run a function when the window size changes
   //note that window size changes do send escape codes to the terminal which
   //can trigger a getchar, so you must enforce the characters pressed.
   //we have used the input manager functions for this.
   atwinch(draw); 
   //using ctype function for input rules
   get_input_rule(isprint);
   return 0;
}

void draw(void) {
   clear();
   char* text = "Try Resizing the Terminal!!";
   char* text2 = "Press Space to Quit!";
   set_style(BOLD | YELLOW);
   locate(rows() / 2,cols() / 2 - strlen(text) / 2);
   printf(text);
   set_style(BOLD | BLUE);
   locate(rows() / 2 + 1,cols() / 2 - strlen(text2) / 2);
   printf(text2);
   set_style(NO_ATTRIBS);
   flush();
}

void at_init(void) {
   atexit(at_exit);
   clear();
   term_buffer_full();
   echo_off();
   locate(0,0);
   toggle_cursor();
   flush();
}

void at_exit(void) {
   toggle_cursor();
   term_buffer_line();
   set_style(NO_ATTRIBS);
   clear();
   echo_on();
   locate(0,0);
   flush();
}
