#include "common.h"
#include "screens.h"

static screen current_screen = NULL;

screen alloc_screen(screen parent,void (draw)(screen), void (run)(screen), void (size)(screen)) {
   screen ret = allocate(screen);
   assert(ret!=NULL);
   ret->parent = parent;
   ret->draw = draw;
   ret->run = run;
   ret->size = size;
   ret->data = NULL;
   ret->dealloc = NULL;
   ret->size(ret);
   return ret;
}

void dealloc_screen(screen scr) {
   if (scr->dealloc != NULL);
      scr->dealloc(scr);
   deallocate(scr);
}
void set_current_screen(screen scr) {
   current_screen = scr;
}

screen get_current_screen(void) {
   return current_screen;
}

static void draw_screen(screen scr) {
   if (scr->parent != NULL) 
      draw_screen(scr->parent);
   scr->draw(scr);
}

static void resize_screen(screen scr) {
   if (scr->parent != NULL)
      resize_screen(scr->parent);
   scr->size(scr);
}

void resize_screens(void) {
   resize_screen(current_screen);
}

void close_current_screen(void) {
   screen temp = NULL;
   if (current_screen->parent != NULL) 
      temp = current_screen->parent;
   dealloc_screen(current_screen);
   current_screen = temp;
}

void draw_current_screen(void) {
   if (current_screen != NULL)
      draw_screen(current_screen);
}

void run_current_screen(void) {
   if (current_screen != NULL)
      current_screen->run(current_screen);
}

