#include "windows.h"
#include "text.h"

typedef struct window_data_t* window_data;
struct window_data_t {
   boxstyle border;
   attributes border_att;
   alignment title_align;
   char* title;
   attributes title_att;
   void (*draw)(screen);
   void (*dealloc)(screen);
   void *data;
   int r,c,w,h;
};

void size_window(screen scr);
void draw_window(screen scr);
void dealloc_window(screen scr);

screen alloc_window(screen parent,int r, int c, int w, int h, boxstyle border, attributes border_att,
                    char* title, attributes title_att,  alignment title_align,void (draw)(screen),void(run)(screen),void(dealloc)(screen)) {
   window_data data = allocate(window_data);
   assert(data != NULL);
   data->border = border;
   data->border_att = border_att;
   data->title = title;
   data->title_att = title_att;
   data->draw = draw;
   data->dealloc = dealloc;
   data->title_align = title_align;
   data->r = r;
   data->c = c;
   data->w = w;
   data->data = NULL;
   data->h = h;   

   screen ret = alloc_screen(parent,draw_window,run,size_window);
   ret->data = data;
   ret->dealloc = dealloc_window;
   size_window(ret);
   return ret;
}

void size_window(screen scr) {
   if (w(scr) != NULL) {
      scr->row =    w(scr)->r;
      scr->col =    w(scr)->c;
      scr->width =  w(scr)->w;
      scr->height = w(scr)->h;
   }
}

void draw_window(screen scr) {   
   set_style(w(scr)->border_att);
   print_box(scr->row-1,scr->col-1,scr->width+2,scr->height+2,w(scr)->border);
   set_style(w(scr)->title_att);
   print_text_wrapped(scr->row-1,scr->col,scr->width,1,w(scr)->title,w(scr)->title_align);   
   set_style(NONE);
   w(scr)->draw(scr);
}

void dealloc_window(screen scr) {
   deallocate(scr->data);   
}
